diff --git a/Documentation/faq/releases.rst b/Documentation/faq/releases.rst
index ec6f90916064..1dd491266f79 100644
--- a/Documentation/faq/releases.rst
+++ b/Documentation/faq/releases.rst
@@ -97,41 +97,47 @@ Q: Are all features available with all datapaths?
       OVS source tree.
 
     Userspace
-      Also known as DPDK, dpif-netdev or dummy datapath. It is the only
-      datapath that works on NetBSD, FreeBSD and Mac OSX.
+      This datapath supports conventional system devices as well as
+      DPDK and AF_XDP devices when support for those is built.  This
+      is the only datapath that works on NetBSD, FreeBSD and Mac OSX.
 
     Hyper-V
       Also known as the Windows datapath.
 
-    The following table lists the datapath supported features from an Open
-    vSwitch user's perspective.
+    The following table lists the datapath supported features from an
+    Open vSwitch user's perspective.  The "Linux upstream" column
+    lists the Linux kernel version that introduced a given feature
+    into its kernel module.  The "Linux OVS tree" and "Userspace"
+    columns list the Open vSwitch release versions that introduced a
+    given feature into the included kernel module or the userspace
+    datapath, respectively.
 
     ========================== ============== ============== ========= =======
     Feature                    Linux upstream Linux OVS tree Userspace Hyper-V
     ========================== ============== ============== ========= =======
-    Connection tracking             4.3            YES          YES      YES
-    Conntrack Fragment Reass.       4.3            YES          YES      YES
-    Conntrack Timeout Policies      5.2            YES          NO       NO
-    Conntrack Zone Limit            4.18           YES          NO       YES
-    NAT                             4.6            YES          YES      YES
-    Tunnel - LISP                   NO             YES          NO       NO
-    Tunnel - STT                    NO             YES          NO       YES
-    Tunnel - GRE                    3.11           YES          YES      YES
-    Tunnel - VXLAN                  3.12           YES          YES      YES
-    Tunnel - Geneve                 3.18           YES          YES      YES
-    Tunnel - GRE-IPv6               4.18           YES          YES      NO
-    Tunnel - VXLAN-IPv6             4.3            YES          YES      NO
-    Tunnel - Geneve-IPv6            4.4            YES          YES      NO
-    Tunnel - ERSPAN                 4.18           YES          YES      NO
-    Tunnel - ERSPAN-IPv6            4.18           YES          YES      NO
-    QoS - Policing                  YES            YES          YES      NO
-    QoS - Shaping                   YES            YES          NO       NO
-    sFlow                           YES            YES          YES      NO
-    IPFIX                           3.10           YES          YES      YES
-    Set action                      YES            YES          YES    PARTIAL
-    NIC Bonding                     YES            YES          YES      YES
-    Multiple VTEPs                  YES            YES          YES      YES
-    Meters                          4.15           YES          YES      NO
+    Connection tracking             4.3            2.5          2.6      YES
+    Conntrack Fragment Reass.       4.3            2.6          2.10     YES
+    Conntrack Timeout Policies      5.2            2.12         NO       NO
+    Conntrack Zone Limit            4.18           2.10         NO       YES
+    NAT                             4.6            2.6          2.8      YES
+    Tunnel - LISP                   NO             2.11         NO       NO
+    Tunnel - STT                    NO             2.4          NO       YES
+    Tunnel - GRE                    3.11           1.0          2.4      YES
+    Tunnel - VXLAN                  3.12           1.10         2.4      YES
+    Tunnel - Geneve                 3.18           2.4          2.4      YES
+    Tunnel - GRE-IPv6               4.18           2.6          2.6      NO
+    Tunnel - VXLAN-IPv6             4.3            2.6          2.6      NO
+    Tunnel - Geneve-IPv6            4.4            2.6          2.6      NO
+    Tunnel - ERSPAN                 4.18           2.10         2.10     NO
+    Tunnel - ERSPAN-IPv6            4.18           2.10         2.10     NO
+    QoS - Policing                  YES            1.1          2.6      NO
+    QoS - Shaping                   YES            1.1          NO       NO
+    sFlow                           YES            1.0          1.0      NO
+    IPFIX                           3.10           1.11         1.11     YES
+    Set action                      YES            1.0          1.0    PARTIAL
+    NIC Bonding                     YES            1.0          1.0      YES
+    Multiple VTEPs                  YES            1.10         1.10     YES
+    Meters                          4.15           1.10         1.10     NO
     ========================== ============== ============== ========= =======
 
     Do note, however: